"object" != typeof JSON && (JSON = {}), function () { "use strict"; var rx_one = /^[\],:{}\s]*$/, rx_two = /\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g, rx_three = /"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, rx_four = /(?:^|:|,)(?:\s*\[)+/g, rx_escapable = /[\\"\u0000-\u001f\u007f-\u009f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g, rx_dangerous = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g, gap, indent, meta, rep; function f(t) { return t < 10 ? "0" + t : t } function this_value() { return this.valueOf() } function quote(t) { return rx_escapable.lastIndex = 0, rx_escapable.test(t) ? '"' + t.replace(rx_escapable, function (t) { var e = meta[t]; return "string" == typeof e ? e : "\\u" + ("0000" + t.charCodeAt(0).toString(16)).slice(-4) }) + '"' : '"' + t + '"' } function str(t, e) { var r, n, o, u, f, a = gap, i = e[t]; switch (i && "object" == typeof i && "function" == typeof i.toJSON && (i = i.toJSON(t)), "function" == typeof rep && (i = rep.call(e, t, i)), typeof i) { case "string": return quote(i); case "number": return isFinite(i) ? String(i) : "null"; case "boolean": case "null": return String(i); case "object": if (!i) return "null"; if (gap += indent, f = [], "[object Array]" === Object.prototype.toString.apply(i)) { for (u = i.length, r = 0; r < u; r += 1)f[r] = str(r, i) || "null"; return o = 0 === f.length ? "[]" : gap ? "[\n" + gap + f.join(",\n" + gap) + "\n" + a + "]" : "[" + f.join(",") + "]", gap = a, o } if (rep && "object" == typeof rep) for (u = rep.length, r = 0; r < u; r += 1)"string" == typeof rep[r] && (o = str(n = rep[r], i)) && f.push(quote(n) + (gap ? ": " : ":") + o); else for (n in i) Object.prototype.hasOwnProperty.call(i, n) && (o = str(n, i)) && f.push(quote(n) + (gap ? ": " : ":") + o); return o = 0 === f.length ? "{}" : gap ? "{\n" + gap + f.join(",\n" + gap) + "\n" + a + "}" : "{" + f.join(",") + "}", gap = a, o } } "function" != typeof Date.prototype.toJSON && (Date.prototype.toJSON = function () { return isFinite(this.valueOf()) ? this.getUTCFullYear() + "-" + f(this.getUTCMonth() + 1) + "-" + f(this.getUTCDate()) + "T" + f(this.getUTCHours()) + ":" + f(this.getUTCMinutes()) + ":" + f(this.getUTCSeconds()) + "Z" : null }, Boolean.prototype.toJSON = this_value, Number.prototype.toJSON = this_value, String.prototype.toJSON = this_value), "function" != typeof JSON.stringify && (meta = { "\b": "\\b", "\t": "\\t", "\n": "\\n", "\f": "\\f", "\r": "\\r", '"': '\\"', "\\": "\\\\" }, JSON.stringify = function (t, e, r) { var n; if (indent = gap = "", "number" == typeof r) for (n = 0; n < r; n += 1)indent += " "; else "string" == typeof r && (indent = r); if ((rep = e) && "function" != typeof e && ("object" != typeof e || "number" != typeof e.length)) throw new Error("JSON.stringify"); return str("", { "": t }) }), "function" != typeof JSON.parse && (JSON.parse = function (text, reviver) { var j; function walk(t, e) { var r, n, o = t[e]; if (o && "object" == typeof o) for (r in o) Object.prototype.hasOwnProperty.call(o, r) && (void 0 !== (n = walk(o, r)) ? o[r] = n : delete o[r]); return reviver.call(t, e, o) } if (text = String(text), rx_dangerous.lastIndex = 0, rx_dangerous.test(text) && (text = text.replace(rx_dangerous, function (t) { return "\\u" + ("0000" + t.charCodeAt(0).toString(16)).slice(-4) })), rx_one.test(text.replace(rx_two, "@").replace(rx_three, "]").replace(rx_four, ""))) return j = eval("(" + text + ")"), "function" == typeof reviver ? walk({ "": j }, "") : j; throw new SyntaxError("JSON.parse") }) }();

function ChopChop(createCutsNoDelete) {

	var timelineCuts;
	var timelineCutsRawText;

	filePath = File.openDialog();

	if (filePath == null) {
		return;
	}

	try {
		timelineCutsRawText = ReadFile(filePath);
	} catch (error) {
		alert('Error reading file');
		return;
	}

	timelineCuts = JSON.parse(timelineCutsRawText);

	var activeSequence = null;
	activeSequence = app.project.activeSequence;

	var sequenceData = [];
	var videoProjectItems = []

	for (var i = 0; i < activeSequence.videoTracks.numTracks; i++) {
		for (var j = 0; j < activeSequence.videoTracks[i].clips.numItems; j++) {

			if (activeSequence.videoTracks[i].clips[j].isSelected()) {

				sequenceData.push({
					track: activeSequence.videoTracks[i],
					projectItem: activeSequence.videoTracks[i].clips[j].projectItem,
					isVideo: true,
					clipStartTime: activeSequence.videoTracks[i].clips[j].start.seconds,
					clipEndTime: activeSequence.videoTracks[i].clips[j].end.seconds
				});
	
				videoProjectItems.push(activeSequence.videoTracks[i].clips[j].projectItem.nodeId.toString());
				
				try {
					activeSequence.videoTracks[i].clips[j].remove(0, 0);
				} catch (e) { }

			}

		}
	}

	// Delete attached audio tracks from video tracks
	for (var i = 0; i < activeSequence.audioTracks.numTracks; i++) {
		for (var j = 0; j < activeSequence.audioTracks[i].clips.numItems; j++) {
			for (var k = 0; k < videoProjectItems.length; k++) {

				try {
					if (videoProjectItems[k] == activeSequence.audioTracks[i].clips[j].projectItem.nodeId.toString()) {
						activeSequence.audioTracks[i].clips[j].remove(0, 0);
					}
				} catch (e) { }

			}

		}
	}

	for (var i = 0; i < activeSequence.audioTracks.numTracks; i++) {
		for (var j = 0; j < activeSequence.audioTracks[i].clips.numItems; j++) {

			if (activeSequence.audioTracks[i].clips[j].isSelected()) {

				sequenceData.push({
					track: activeSequence.audioTracks[i],
					projectItem: activeSequence.audioTracks[i].clips[j].projectItem,
					isVideo: false,
					clipStartTime: activeSequence.audioTracks[i].clips[j].start.seconds,
					clipEndTime: activeSequence.audioTracks[i].clips[j].end.seconds
				});

				try {
					activeSequence.audioTracks[i].clips[j].remove(0, 0);
				} catch (e) { }
	

			}

		}
	}

	if (sequenceData.length <= 0) { alert("No clips selected"); return; }

	var timelineItemsScope = timelineCuts.length;
	if (createCutsNoDelete == false) {
		for (var i = timelineCuts.length - 1; i >= 0; i--) {
			if (timelineCuts[i].operation == 'keep') {
				timelineItemsScope = i + 1;
				break;
			}
		}
	}

	for (var sequenceIndex = 0; sequenceIndex < sequenceData.length; sequenceIndex++) {

		var insertAt = 0;
		var currentClipStartTime = 0;
		var currentClipEndTime = 0;

		currentClipStartTime = sequenceData[sequenceIndex].clipStartTime;
		currentClipEndTime = sequenceData[sequenceIndex].clipEndTime;

		DeleteAllMarkers();

		var clipInsertIndexCounter = -1;

		for (var i = 0; i < timelineCuts.length && timelineCuts[i].start < currentClipEndTime; i++) {

			try {
				if (timelineCuts[i].marked) {
					activeSequence.markers.createMarker(timelineCuts[i].start);
				}
			} catch (e) { }

			var toRunOrNotToRun = false;

			if (createCutsNoDelete) {

				toRunOrNotToRun = true;

				if (timelineCuts[i].operation == 'remove') {

					sequenceData[sequenceIndex].projectItem.setColorLabel(6);

				} else if (timelineCuts[i].operation == 'fastforward') {

					sequenceData[sequenceIndex].projectItem.setColorLabel(7);

				} else {

					sequenceData[sequenceIndex].projectItem.setColorLabel(1);

				}

			} else {

				if (timelineCuts[i].operation == 'keep') {

					sequenceData[sequenceIndex].projectItem.setColorLabel(1);

					toRunOrNotToRun = true;

				} else if (timelineCuts[i].operation == 'fastforward') {

					toRunOrNotToRun = true;

					sequenceData[sequenceIndex].projectItem.setColorLabel(7);

				}

			}

			if (toRunOrNotToRun) {

                k = new Time();
                k.seconds = timelineCuts[i].start - currentClipStartTime;

                if (timelineCuts[i].start < currentClipStartTime && timelineCuts[i].start + timelineCuts[i].duration > currentClipStartTime) {
                    k.seconds = 0;
                }

                try {
                    sequenceData[sequenceIndex].projectItem.setInPoint(k.ticks, 4);
                } catch (e) { }

                if (i < timelineItemsScope - 1) {

                    k = new Time();
                    k.seconds = timelineCuts[i + 1].start - currentClipStartTime + 0.5;

                    if(k.seconds > currentClipEndTime - currentClipStartTime) {
                        k = new Time();
                        k.seconds = currentClipEndTime - currentClipStartTime;
                    }

                    try {
                        sequenceData[sequenceIndex].projectItem.setOutPoint(k.ticks, 4);
                    } catch (e) { }

                } else {

                    if (i + 1 < timelineCuts.length) {

                        k = new Time();
                        k.seconds = timelineCuts[i + 1].start - currentClipStartTime;

                        try {
                            sequenceData[sequenceIndex].projectItem.setOutPoint(k.ticks, 4);
                        } catch (e) { }

                    } else {

                        try {
                            sequenceData[sequenceIndex].projectItem.clearOutPoint();
                        } catch (e) { }

                    }

                }

                t = new Time();
                t.seconds = insertAt;

                if (timelineCuts[i].start < currentClipStartTime && timelineCuts[i].start + timelineCuts[i].duration > currentClipStartTime) {
                    t.seconds += currentClipStartTime - timelineCuts[i].start;
                }

				if (currentClipStartTime < timelineCuts[i].start + timelineCuts[i].duration) {

					try {
						sequenceData[sequenceIndex].track.overwriteClip(sequenceData[sequenceIndex].projectItem, t.ticks);
						clipInsertIndexCounter++;
					} catch (e) { }

				}

                insertAt += timelineCuts[i].duration;

				if (timelineCuts[i].punched > 1 && sequenceData[sequenceIndex].isVideo) {

					var amountX = 0.5;
					var amountY = 0.5;

					switch (timelineCuts[i].punchedPosition) {
						case 'center':

							break;
						case 'top-left':

							amountX = 0.5 + ((timelineCuts[i].punched - 1) / 2);
							amountY = 0.5 + ((timelineCuts[i].punched - 1) / 2);

							break;
						case 'top-right':

							amountX = 0.5 - ((timelineCuts[i].punched - 1) / 2);
							amountY = 0.5 + ((timelineCuts[i].punched - 1) / 2);

							break;
						case 'bottom-left':

							amountX = 0.5 + ((timelineCuts[i].punched - 1) / 2);
							amountY = 0.5 - ((timelineCuts[i].punched - 1) / 2);

							break;
						case 'bottom-right':

							amountX = 0.5 - ((timelineCuts[i].punched - 1) / 2);
							amountY = 0.5 - ((timelineCuts[i].punched - 1) / 2);

							break;
						case 'top':

							amountX = 0.5;
							amountY = 0.5 + ((timelineCuts[i].punched - 1) / 2);

							break;
						case 'bottom':

							amountX = 0.5;
							amountY = 0.5 - ((timelineCuts[i].punched - 1) / 2);

							break;
						case 'left':

							amountX = 0.5 + ((timelineCuts[i].punched - 1) / 2);
							amountY = 0.5;

							break;
						case 'right':

							amountX = 0.5 - ((timelineCuts[i].punched - 1) / 2);
							amountY = 0.5;

							break;
						default:
							break;
					}

					sequenceData[sequenceIndex].track.clips[clipInsertIndexCounter].components[1].properties[1].setValue(parseInt(timelineCuts[i].punched * 100), 1);
					sequenceData[sequenceIndex].track.clips[clipInsertIndexCounter].components[1].properties[0].setValue([amountX, amountY], 1);

				}

			}

		}

		k = new Time();
		k.seconds = 0;

		try {
			sequenceData[sequenceIndex].projectItem.setInPoint(k.ticks, 4);
		} catch (e) { }

		try {
			sequenceData[sequenceIndex].projectItem.clearOutPoint();
		} catch (e) { }

	}

	return;

}

function DeleteAllMarkers() {

	var markers = app.project.activeSequence.markers;
	var marker = markers.getFirstMarker();

	while (marker) {
		markers.deleteMarker(marker);
		marker = markers.getFirstMarker();
	}

}

function ReadFile(filePath) {

	var scriptFile;

	try {
		scriptFile = File(filePath);
	} catch (e) {
		alert('Error setting filepath');
		return;
	}

	try {
		scriptFile.open('rw');
	} catch (e) {
		alert('Error opening the file');
		return;
	}

	var content;

	try {
		content = scriptFile.read();
	} catch (e) {
		alert('Error reading the file');
		return;
	}

	try {
		scriptFile.close();
	} catch (e) {
		alert('Error closing the file');
		return;
	}

	return content;

}

function Logger(logText) {

	var fileContents = ReadFile('C:/Users/Quinston/Desktop/logs.txt');

	var fileObj = File('C:/Users/Quinston/Desktop/logs.txt')
	fileObj.open("w");
	fileObj.write(fileContents + logText + '\n');

	fileObj.close();

}